#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <queue>


typedef long long ll;
typedef long double ld;

using namespace std;

const int MAXN = 510000;

int a[MAXN];
int n, m;
int solve() {
	int cnt = 0;
	int lst = 0;
	for (int i = 0; i < n; ++i) {
		if (a[i] > lst) {
			++cnt;
			lst = a[i];
		}
	}
	return cnt;
}

int solver() {
	int cnt = 0;
	int lst = 1000000001;
	for (int i = n - 1; i >= 0; --i) {
		if (a[i] < lst)
			lst = a[i], ++cnt;
	}
	return cnt;
}



int main() {
	cin >> n >> m;
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		--x;
		int tmp = a[x];
		a[x] = y;
		cout << max(solver(), solve()) << "\n";
		a[x] = tmp;
	}
	return 0;
}


