#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <queue>


typedef long long ll;
typedef long double ld;

using namespace std;

const int MAXN = 100000;
const int INF = 1000000001;
int go[MAXN];
int a[MAXN];

int n, m;

int solve() {
	fill(go, go + n + 1, INF);
	go[0] = 0;
	int mx = 0;
	for (int i = 0; i < n; ++i) {
		int x = lower_bound(go, go + n + 1, a[i]) - go;
		go[x] = a[i];
		mx = max(mx, x);
	}
	return mx;
}

int main() {
	scanf("%d%d", &n, &m);
	if (n >= MAXN || m >= MAXN)
		while (true);
	for (int i = 0; i < n; ++i)
		scanf("%d", a + i);
	for (int i = 0; i < m; ++i) {
		int x, y;
		scanf("%d%d", &x, &y);
		--x;
		int tmp = a[x];
		a[x] = y;
		printf("%d\n", solve());
		a[x] = tmp;
	}
	return 0;
}


