#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <queue>


typedef long long ll;
typedef long double ld;

using namespace std;
const int INF = 1000000010;
const int MAXN = 500001;

int n, m;
int a[MAXN];
int go[MAXN];


int solve() {
	fill(go, go + n + 1, INF);
	go[0] = 0;
	for (int i = 0; i < n; ++i)
		for (int j = 0; go[j] < a[i]; ++j)
			go[j + 1] = min(go[j + 1], a[i]);
	int mx = 0;
	for (int i = 0; i <= n; ++i)
		if (go[i] != INF)
			mx = i;
	return mx;
}


int main() {
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; ++i)
		scanf("%d", a + i);
	for (int i = 0; i < m; ++i) {
		int x, y;
		scanf("%d%d", &x, &y);
		--x;
		int tmp = a[x];
		a[x] = y;
		printf("%d\n", solve());
		a[x] = tmp;
	}
	
	return 0;
}


