#include "testlib.h"
#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <queue>

typedef long long ll;
typedef long double ld;

using namespace std;

const int MAXN[] = {15, 15, 500, 2000, 10000, 75000, 400000};
const int MAXM[] = {15, 15, 500, 3000, 20000, 75000, 400000};
const int MAXH[] = {100, 100, 500, 100000, 100000, 1000000000, 1000000000};

int main(int argc, char **argv) {
	registerValidation(argc, argv);
	int gr = atoi(validator.group().data());
	ensure(gr >= 0 && gr <= 6);
	int n = inf.readInt(1, MAXN[gr]);
	inf.readSpace();
	int m = inf.readInt(1, MAXM[gr]);
	inf.readEoln();
	for (int i = 0; i < n; ++i) {
		inf.readInt(1, MAXH[gr]);
		if (i != n - 1)
			inf.readSpace();
	}
	inf.readEoln();
	for (int i = 0; i < m; ++i) {
		inf.readInt(1, n);
		inf.readSpace();
		inf.readInt(1, MAXH[gr]);
		inf.readEoln();
	}
	inf.readEof();
	return 0;
}


