#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <queue>


typedef long long ll;
typedef long double ld;

using namespace std;


const int MAXN = 500100;
const int INF = 1000000010;
int n, m;
int a[MAXN];
vector<pair<int, int> > go[MAXN];
int f[MAXN];
int gl[MAXN];
int gr[MAXN];
int ans[MAXN];
int cnt[MAXN];
int res[MAXN];
int mx;

int main() {
	scanf("%d%d", &n, &m);
	for (int i = 0; i < n; ++i)
		scanf("%d", a + i);
	for (int i = 0; i < m; ++i) {
		int x, y;
		scanf("%d%d", &x, &y);
		--x;
		go[x].push_back(make_pair(y, i));
	}
	fill(f, f + n + 1, INF);
	f[0] = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < (int)go[i].size(); ++j) {
			int k = go[i][j].first;
			int kk = lower_bound(f, f + n + 1, k) - f;
			ans[go[i][j].second] = kk;
		}
		int kk = lower_bound(f, f + n + 1, a[i]) - f;
		f[kk] = a[i];
		gl[i] = kk;
		mx = max(mx, kk);
	}
	fill(f, f + n + 1, INF);
	f[0] = 0;
	for (int i = n - 1; i >= 0; --i) {
		for (int j = 0; j < (int)go[i].size(); ++j) {
			int k = go[i][j].first;
			int kk = lower_bound(f, f + n + 1, INF - k) - f;
			ans[go[i][j].second] += kk - 1;
		}
		int kk = lower_bound(f, f + n + 1, INF - a[i]) - f;
		f[kk] = INF - a[i];
		gr[i] = kk;
	}
	for (int i = 0; i < n; ++i)
		if (gl[i] + gr[i] - 1 == mx)
			++cnt[gl[i]];
	for (int i = 0; i < n; ++i)
		for (pair<int, int> j: go[i]) {
			int aa = max(mx - 1, ans[j.second]);
			if (gl[i] + gr[i] - 1 != mx || cnt[gl[i]] != 1)
				aa = max(aa, mx);
			res[j.second] = aa;
		}
	for (int i = 0; i < m; ++i)
		printf("%d\n", res[i]);
	return 0;
}


