#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <queue>


typedef long long ll;
typedef long double ld;

using namespace std;

const ll MOD = 1000000007;
const int MAXN = 500006;
int n, m;


ll cntl[MAXN];
int gol[MAXN];
ll cntr[MAXN];
int gor[MAXN];
int a[MAXN];
int fl[MAXN];

int main() {
	cin >> n >> m;
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	int gmx = 0;
	ll gcnt = 1;
	for (int i = 0; i < n; ++i) {
		ll cnt = 1;
		ll mx = 0;
		for (int j = 0; j < i; ++j) {
			if (a[j] >= a[i])
				continue;
			if (gol[j] > mx)
				mx = gol[j], cnt = 0;
			if (gol[j] == mx)
				cnt = (cnt + cntl[j]) % MOD;
		}
		cntl[i] = cnt;
		gol[i] = mx + 1;
		if (gmx < gol[i])
			gmx = gol[i], gcnt = 0;
		if (gmx == gol[i])
			gcnt = (gcnt + cntl[i]) % MOD;
	}

	for (int i = n - 1; i >= 0; --i) {
		ll cnt = 1;
		ll mx = 0;
		for (int j = i + 1; j < n; ++j) {
			if (a[j] <= a[i])
				continue;
			if (gor[j] > mx)
				mx = gor[j], cnt = 0;
			if (gor[j] == mx)
				cnt = (cnt + cntr[j]) % MOD;
		}
		cntr[i] = cnt;
		gor[i] = mx + 1;
	}

	for (int i = 0; i < n; ++i) {
		if (gol[i] + gor[i] - 1 == gmx && (cntl[i] * cntr[i]) % MOD == gcnt)
			fl[i] = 1;
	}

	for (int i = 0; i < m; ++i) {
		int x, y;
		cin >> x >> y;
		--x;
		int ans = max(0, gmx - fl[x]);
		int gl = 0;
		int gr = 0;
		for (int j = 0; j < x; ++j)
			if (a[j] < y)
				gl = max(gl, gol[j]);
		for (int j = x + 1; j < n; ++j)
			if (a[j] > y)
				gr = max(gr, gor[j]);
		ans = max(ans, gl + 1 + gr);
		cout << ans << "\n";
	}
	return 0;
}


