#include <iostream>
#include <fstream>
#include <set>
#include <map>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <cstring>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <queue>


typedef long long ll;
typedef long double ld;

using namespace std;
const int MX = 100010;
const int MAXN = 110000;
int ff[MX];
int a[MAXN];
int n, m;

int get(int x) {
	int ans = 0;
	for (; x >= 0; x &= x + 1, --x)
		ans = max(ans, ff[x]);
	return ans;
}

void upd(int x, int y) {
	for (; x < MX; x |= x + 1)
		ff[x] = max(ff[x], y);
}

int solve() {
	memset(ff, 0, sizeof(ff));
	int mx = 0;
	for (int i = 0; i < n; ++i) {
		int x = get(a[i] - 1);
		mx = max(mx, x + 1);
		upd(a[i], x + 1);
	}
	return mx;
}

int main() {
	cin >> n >> m;
	if (n >= MAXN || m >= MAXN)
	    while (true);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		if (a[i] >= MX)
			while (true);
	}
	for (int i = 0; i < m; ++i) {
		int x, y;
		scanf("%d%d", &x, &y);
		if (y >= MX)
			while (true);
		--x;
		int tmp = a[x];
		a[x] = y;
		cout << solve() << "\n";
		a[x] = tmp;
	}
	return 0;
}


