import java.io.*;
import java.math.*;
import java.util.*;

public class ra_n2log_java_v2 {

  BufferedReader br;
  PrintWriter out;
  StringTokenizer st;
  boolean eof;

  int a[];
  int p[];
  int head[];
  int head2[];
  int next[];
  int e[];
  int cl[];
  int r[];
  int ec = 0;
  void add2(int x, int y) {
    ec++;
    next[ec] = head[x];
    head[x] = ec;
    e[ec] = y;
  }
  void add3(int x, int y) {
    ec++;
    next[ec] = head2[x];
    head2[x] = ec;
    e[ec] = y;
  }
  void add(int u, int v) {
    if (a[u] < a[v]) {
      add3(v, u);
    } else {
      add2(u, v);
      add2(v, u);
    }
  }
  int cnt = 0;
  void dfs(int v) {
    cl[v] = cnt;
    for (int bb = head[v]; bb != 0; bb = next[bb]) if (cl[e[bb]] == 0) {
      dfs(e[bb]);
    }
  }
  
  void solve() throws IOException {
    int n = nextInt();
    int m = nextInt();
    int N = n * m;
    a = new int[N];
    for (int i = 0; i < N; i++) {
      a[i] = nextInt();
    }
    st = null;
    br.close();
    br = null;
    p = new int[N];
    head = new int[N];
    head2 = new int[N];
    next = new int[N * 4];
    e = new int[N * 4];
    cl = new int[N];
    r = new int[N + 1];
    Integer[] P = new Integer[N];
    for (int i = 0; i < N; i++) {
      P[i] = i;
    }
    Arrays.sort(P, new Comparator<Integer>(){
      @Override
      public int compare(Integer x, Integer y) {
        return a[x] - a[y];
      }
    });
    for (int i = 0; i < N; i++) {
      p[i] = P[i];
    }
    int lsx[][] = new int[n][m];
    int cx[] = new int[n];
    int lsy[][] = new int[m][n];
    int cy[] = new int[m];    
    for (int i = 0; i < N; i++) {
      int x = p[i] / m;
      int y = p[i] % m;
      lsx[x][cx[x]++] = p[i];
      lsy[y][cy[y]++] = p[i];
    }  
    for (int i = 0; i < n; i++) {    
      for (int j = 0; j + 1 < m; j++) {
        add(lsx[i][j], lsx[i][j + 1]);
      }
    }
    for (int i = 0; i < m; i++) {
      for (int j = 0; j + 1 < n; j++) {
        add(lsy[i][j], lsy[i][j + 1]);
      }
    }
    for (int j = 0; j < N; j++) {
      int i = p[j];
      if (cl[i] == 0) {
        ++cnt;
        dfs(i);
      }
      r[j + 1] = 1;
    }
    for (int j = 0; j < N; j++) {
      int i = p[j];
      for (int bb = head2[i]; bb != 0; bb = next[bb]) {
        if (r[cl[i]] < r[cl[e[bb]]] + 1) {
          r[cl[i]] = r[cl[e[bb]]] + 1;
        }
      }
    }
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < m; j++) {
        out.print(r[cl[i * m + j]]);
        if (j + 1 < m) {
          out.print(" ");
        } else {
          out.println();
        }
      }
    }
  }

  ra_n2log_java_v2() throws IOException {
    br = new BufferedReader(new InputStreamReader(System.in));
    out = new PrintWriter(System.out);
    solve();
    out.close();
  }

  public static void main(String[] args) throws IOException {
    new ra_n2log_java_v2();
  }

  String nextToken() {
    while (st == null || !st.hasMoreTokens()) {
      try {
        st = new StringTokenizer(br.readLine());
      } catch (Exception e) {
        eof = true;
        return null;
      }
    }
    return st.nextToken();
  }

  String nextString() {
    try {
      return br.readLine();
    } catch (IOException e) {
      eof = true;
      return null;
    }
  }

  int nextInt() throws IOException {
    return Integer.parseInt(nextToken());
  }

  long nextLong() throws IOException {
    return Long.parseLong(nextToken());
  }

  double nextDouble() throws IOException {
    return Double.parseDouble(nextToken());
  }
}
