#include "testlib.h"
using namespace std;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    string type = argv[1];
    bool shuffle_first = (type == "first" || type == "both");
    bool shuffle_second = (type == "second" || type == "both");
    bool same = (type == "same");
    int n;
    scanf("%d", &n);
    printf("%d\n", n);
    vector<int> same_P(n);
    for (int i = 0; i < n; i++)
        same_P[i] = i + 1;
    shuffle(same_P.begin(), same_P.end());
    for (bool need_shuffle : {shuffle_first, shuffle_second}) {
        vector<int> P(n);
        for (int i = 0; i < n; i++)
            P[i] = i + 1;
        if (need_shuffle)
            shuffle(P.begin(), P.end());
        if (same)
            P = same_P;
        for (int i = 0; i < n - 1; i++) {
            int a, b;
            scanf("%d %d", &a, &b);
            printf("%d %d\n", P[a - 1], P[b - 1]);
        }
    }
}
