#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;

#define all(c) (c).begin(),(c).end()
#define sz(c) (int)(c).size()
#define pb push_back
#define mp make_pair
#define x first
#define y second
#define next next_fdgsd
#define prev prev_fdgsd
#define image(a) {sort(all(a)), a.resize(unique(all(a)) - a.begin());}
const int maxn = 500010;
const int maxe = maxn * 4;
int head[2][maxn];
int tail[2][maxn];
int next[maxe];
int e[maxe];
int wh[maxe];

int g[maxn];
int h[maxn];
int up(int x) {
  if (x == g[x]) return x;
  return g[x] = up(g[x]);
}
void join(int x, int y) {
  int& h1 = head[1][x];
  int& t1 = tail[1][x];
  if (h1 == 0) {
    return;
  }
  int& h2 = head[1][y];
  int& t2 = tail[1][y];  
  if (h2 == 0) {
    h2 = h1;
    t2 = t1;
    h1 = 0;
    t1 = 0;
    return;
  }
  next[t2] = h1;
  t2 = t1;
  h1 = 0;
  t1 = 0;
}
void merge(int x, int y, bool fl) {
  x = up(x);
  y = up(y);
  if (x == y) return;
  if (h[x] < h[y]) {
    g[x] = y;
    if (fl) {
      join(x, y);
    }
  } else {
    if (h[x] == h[y]) {
      h[x]++;
    }
    g[y] = x;
    if (fl) {
      join(y, x);
    }
  }
}
int ke = 1;
void add2(int k, int x, int y) {
  ++ke;
  if (head[k][x] == 0) {
    tail[k][x] = ke;
  }
  next[ke] = head[k][x];
  head[k][x] = ke;
  e[ke] = y;
}
void add(int k, int x, int y) {
  add2(k, x, y);
  add2(k, y, x);
}
int get(int v) {
  v = up(v);
  for (int bb = head[1][v]; bb; bb = next[bb]) {
    if (wh[bb] == 1) {        
      head[1][v] = bb;
      return bb;
    }
  }
  assert(false);
}
int CNT = 0;
int was[maxn];
vector<int> s0;
void dfs_diff(int v, int pr) {
  for (int bb = head[0][v]; bb; bb = next[bb]) if (e[bb] != pr) {
    dfs_diff(e[bb], v);
  }
  CNT++;
  int prbb = -1;
  for (int bb = head[0][v]; bb; bb = next[bb]) {
    if (e[bb] == pr) {
      prbb = bb;
    }
    was[e[bb]] = CNT;
  }
  for (int bb = head[1][v]; bb; bb = next[bb]) {
    if (was[e[bb]] != CNT) {
      wh[bb] = 1;
    }
    was[e[bb]] = CNT + 1;
  }
  CNT++;
  if (pr != -1 && was[pr] != CNT) {
    s0.pb(prbb);
  }
}

int main(){
  #ifdef home
  assert(freopen("a.out","wt",stdout));
  assert(freopen("a.in","rt",stdin));
  #endif              
  int n;
  scanf("%d", &n);
  for (int k = 0; k < 2; k++) {
    for (int i = 0; i < n - 1; i++) {
      int x, y;
      scanf("%d %d", &x, &y);
      x--, y--;
      add(k, x, y);
    }
  }
  dfs_diff(0, -1);
  for (int v = 0; v < n; v++) {
    g[v] = v; 
  }
  for (int v = 0; v < n; v++) {
    for (int bb = head[1][v]; bb; bb = next[bb]) {
      if (wh[bb] == 0) {
        merge(v, e[bb], 0);
      }
    }
  }
  for (int v = 0; v < n; v++) {
    int u = up(v);
    if (v != u) {
      join(v, u);
    }
  }  
  printf("%d\n", sz(s0));
  for (auto e0 : s0) {
    int e1 = get(e[e0 ^ 1]);
    printf("%d %d %d %d\n", e[e0] + 1, e[e0 ^ 1] + 1, e[e1] + 1, e[e1 ^ 1] + 1);
    wh[e1] = wh[e1 ^ 1] = 0;
    merge(e[e1], e[e1 ^ 1], 1);
  }
  return 0;
}