#include <algorithm>
#include <cassert>
#include <vector>
using namespace std;

int main() {
    int n;
    scanf("%d", &n);
    vector<pair<int, int>> first, second;
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        scanf("%d %d", &a, &b);
        if (a > b)
            swap(a, b);
        first.emplace_back(a, b);
    }
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        scanf("%d %d", &a, &b);
        if (a > b)
            swap(a, b);
        second.emplace_back(a, b);
    }
    sort(first.begin(), first.end());
    sort(second.begin(), second.end());
    vector<pair<int, int>> diff_ab(n - 1), diff_ba(n - 1);
    int d1 = set_difference(first.begin(), first.end(), second.begin(), second.end(), diff_ab.begin()) - diff_ab.begin();
    int d2 = set_difference(second.begin(), second.end(), first.begin(), first.end(), diff_ba.begin()) - diff_ba.begin();
    assert(d1 == d2 && d1 <= 1 && d2 <= 1);
    if (d1)
        printf("1\n%d %d %d %d\n", diff_ab[0].first, diff_ab[0].second, diff_ba[0].first, diff_ba[0].second);
    else
        printf("0\n");
}
